#ifndef __GAME_SCREEN
#define __GAME_SCREEN

#include <d3d9.h>
#include <set>
#include <algorithm>

class Screen;

/**
 * `ΏۃIuWFNg
 */
class ScreenObject { 
	friend class Screen;
public:
	ScreenObject(Screen *screen, int index);
	~ScreenObject();
	
	void setIndex(int index);

protected:
	Screen *screen;
	int index;
	bool visible;
	virtual void render(LPDIRECT3DDEVICE9 pD3DDevice) = 0;
};

/**
 * `x[X
 */
class Screen {

	friend class ScreenObject;
public:
	/**
	 * RXgN^
	 */
	Screen();

	/**
	 * fXgN^
	 */
	~Screen();

	/**
	 * 
	 * @param hWnd EChEnh
	 * @return  true
	 */
	bool init(HWND hWnd);

	/**
	 * ʃ_Os
	 */
	void render();
	
protected:
	LPDIRECT3D9 pD3D;
	LPDIRECT3DDEVICE9 pD3DDevice;

	typedef ScreenObject *OBJP;

	// r֐: index Ń\[g
	struct lessObj : std::binary_function <ScreenObject*,ScreenObject*,bool> {
		bool operator() (const OBJP &obj1, const OBJP &obj2) {
			return obj1->index < obj2->index;
		}
	};
	typedef std::multiset<OBJP,lessObj> ObjSet;
	// IuWFNgo^p
	ObjSet all;

	void add(ScreenObject *obj);
	void remove(ScreenObject *obj);
};

#endif
